import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { Integral, IntegralParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询签到积分
 */
export async function pageIntegral(params: IntegralParam) {
  const res = await request.get<ApiResult<PageResult<Integral>>>(
    MODULES_API_URL + '/booking/integral/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询签到积分列表
 */
export async function listIntegral(params?: IntegralParam) {
  const res = await request.get<ApiResult<Integral[]>>(
    MODULES_API_URL + '/booking/integral',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加签到积分
 */
export async function addIntegral(data: Integral) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/integral',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改签到积分
 */
export async function updateIntegral(data: Integral) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/integral',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除签到积分
 */
export async function removeIntegral(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/integral/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除签到积分
 */
export async function removeBatchIntegral(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/integral/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询签到积分
 */
export async function getIntegral(id: number) {
  const res = await request.get<ApiResult<Integral>>(
    MODULES_API_URL + '/booking/integral/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
